diff --git a/src/wio/lang/wio.fr.pl b/src/wio/lang/wio.fr.pl
index 9e8bdbc22..4085fa092 100644
--- a/src/wio/lang/wio.fr.pl
+++ b/src/wio/lang/wio.fr.pl
@@ -24,8 +24,8 @@
 'wio cron' => 'Interval de temps pour la mise à jour :',
 'wio_ovpn_cron' => 'Interval de temps pour vérifier l\'état d\'OpenVPN RW et IPsec :',
 'wio_save' => 'Sauvegarder',
-'wio_error' => 'message d\'erreur :',
-'wio_info' => 'message :',
+'wio_error' => 'Message d\'erreur :',
+'wio_info' => 'Message d\'info :',
 'wio_back' => 'Retour',
 'wio_use' => 'Importer cette config ?',
 'wio_ip_error' => 'Adresse IP invalide.',
@@ -38,30 +38,30 @@
 'wio_import_leases' => 'Import settings :',
 'wio network' => 'Réseau',
 'wio_refresh' => 'maj de tous les clients maintenant',
-'wio_fqdn_error' => 'Nom de domaine (FQDN) invalide ! Veuillez ne pas utiliser de caractères spéciaux ni de blancs dans le nom de domaine.',
+'wio_fqdn_error' => 'Nom de domaine (FQDN) invalide ! Veuillez ne pas utiliser de caractères spéciaux ou d\'espace dans le nom de domaine.',
 'wio_edit' => 'Modifier les paramètres :',
 'wio_dyndns' => 'DynDNS ',
 'wio_dyndns_hosts' => 'Nom(s) DynDNS',
 'wio_dyndns_refresh' => 'Mise à jour IP de l\'hôte DynDNS',
-'wio_dyndns_on' => 'DynDNS Host activé (cliquer pour désactiver)',
+'wio_dyndns_on' => 'Hôte DynDNS activé (cliquer pour désactiver)',
 'wio_dyndns_off' => 'Hôte DynDNS désactivé (cliquer pour activer)',
 'wio_dyndns_info' => 'Aucune adresse IP enregistrée, car apparemment aucune connexion n’existe sur Internet. Avec la prochaine connexion Internet est réalisée une actualisation de l\'IP des hôtes DynDNS.',
 'wio_no_csv' => 'Le fichier n\'a pas l\'extension .csv',
-'wio_no_csv_error' => 'Veuillez ne pas utiliser de caractères spéciaux ou vides dans le nom de fichier.',
+'wio_no_csv_error' => 'Veuillez ne pas utiliser de caractères spéciaux ou d\'espace dans le nom de fichier.',
 'wio_no_file_selected' => 'Aucun fichier choisi !',
 'wio_import_infos' => 'Importer les configurations :',
-'wio_import_infos_csv' => 'NOTE : Seuls les enregistrements de données marqués "Importer ces paramètres ?" sont considérés comme importants ! Si des enregistrements de données avec une double adresse IP ou des noms d\'hôte doivent se faire, seul le premier enregistrement de données sera importé et les autres enregistrements de données (avec les adresses IP ou noms d\'hôte doubles) ne seront pas pris en compte !',
+'wio_import_infos_csv' => 'NOTE : Seuls les enregistrements de données marqués "Importer cette config ?" seront traités ! Si des enregistrements de données avec une double adresse IP ou plusieurs noms d\'hôte sont présents, seul le premier sera importé et les autres (avec les adresses IP ou noms d\'hôte doubles) ne seront pas pris en compte !',
 'enable disable dyndns' => 'Activer ou désactiver l\'hôte DynDNS',
 'wio_msg' => 'L\'état du ou des clients examinés est mis à jour...',
-'wio_lanname' => 'Nom LAN',
-'wio_wanname' => 'Nom WAN',
+'wio_lanname' => 'Nom d\'hôte LAN',
+'wio_wanname' => 'Nom d\'hôte WAN',
 'wio_sc_refresh' => 'Mettre à jour le client maintenant',
 'wio_edit_settings' => 'Ajout manuel d\'un client :',
-'wio_edit_client' => 'Edition client :',
+'wio_edit_client' => 'Modification du client :',
 'wio_graphs' => 'Afficher le graphique',
 'wio_no_graphs' => 'Pas de graphique disponible',
 'wio_graphs_stat' => 'Graphique pour',
-'wio_vpn_con' => 'Connexion(s) IPsec :',
+'wio_vpn_con' => 'Connexion(s) VPN :',
 'wio_wan_con' => 'Connexion WAN :',
 'wio_clients' => 'Clients :',
 'wio click to disable' => 'Activé',
@@ -84,7 +84,7 @@
 'wio_wan_down' => 'NON CONNECTE',
 'wio_n2n' => 'Connexion site-à-site',
 'wio_rw' => 'Connexion client nomade',
-'wio_mailremark_enabled' => 'Ajouter une remarque du client au corps de l\'email ?',
+'wio_mailremark_enabled' => 'Ajouter la remarque du client au corps de l\'email ?',
 'wio_mail_online_on' => 'Email en ligne activé (cliquer pour désactiver)',
 'wio_mail_online_off' => 'Email en ligne désactivé (cliquer pour activer)',
 'wio_mail_offline_on' => 'Email hors ligne activé (cliquer pour désactiver)',
@@ -138,18 +138,18 @@
 'wio_msg_blue' => 'bleu',
 'wio_msg_red' => 'rouge',
 'wio_msg_orange' => 'orange',
-'wio_msg_center' => 'l\'interface',
+'wio_msg_center' => 'sur son interface',
 'wio_msg_right' => 'est en cours.',
 'wio_msg_hint' => 'Un moment SVP...',
 'wio_last_update' => 'Dernière mise à jour',
-'wio_disable_hint' => 'Attention ! Tous les paramètres vont être réinitialisés , y compris le client à vérifier !',
-'wio_clientremark' => 'Afficher la remarque ?',
+'wio_disable_hint' => 'Attention ! Tous les paramètres vont être réinitialisés, y compris le client à vérifier !',
+'wio_clientremark' => 'Afficher les remarques ?',
 'wio_already_running' => 'Cette vérification est déjà en cours d\'exécution !',
-'wio_error_function' => 'Cette fonction est temporairement indisponible, car en arrière-plan les états du client sont mis à jour (actif / inactif).',
+'wio_error_function' => 'Cette action est temporairement indisponible, car les statuts des clients sont actuellement mis à jour en arrière-plan (actif / inactif).',
 'wio_unknown_lan' => 'INCONNU',
 'wio_red_lan' => 'ROUGE',
 'wio_search' => 'Recherche d\'hôtes actifs sur le réseau local...',
-'wio_answer' => 'Answer',
+'wio_answer' => 'Réponse',
 'wio_answer_time' => 'Temps de réponse',
 'wio_scriptruntime' => 'Temps d\'exécution du script',
 'wio_show_table_off' => 'Cacher la table',